#include <OSIncludes.h>

#pragma header

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <linkerfunc.h>

#ifdef __MAXON__
#include <pragma/exec_lib.h>
#include <pragma/dos_lib.h>
#else
#include <proto/exec.h>
#include <proto/dos.h>
#endif

//#include "compiler.h"
#include "DoomAttackMusic.h"
#include "funcs.h"
#include "musicIDs.h"

/*=====================*/

static int *gametic;
static int *snd_MusicVolume;

static char	**myargv;
static int	myargc;

static void (*I_Error)(char *error, ...);
static int (*M_CheckParm)(char *check);



/*********************************************************/

void C_DAM_Init(struct DAMInitialization *daminit)
{
		// link function pointers to DoomAttack routines
		
		#ifdef __MAXON__
		InitModules();
		#endif
		
		
		I_Error=daminit->I_Error;
		M_CheckParm=daminit->M_CheckParm;

		// setups vars
				
		gametic         = daminit->gametic;
		snd_MusicVolume = daminit->snd_MusicVolume;
		myargv			 = daminit->myargv;
		myargc			 = daminit->myargc;
		
		// Tell DoomAttack the informations, it needs
		
		daminit->numchannels = ????;

}

/*********************************************************

DAM_InitMusic:

Do initialization and return TRUE if everything went OK.
If you return FALSE you must free already alloced resour-
ces as DoomAttack will not call DAM_ShutdownMusic in this
case!!


*********************************************************/



int C_DAM_InitMusic(void)
{
	return ???;
}

/*********************************************************

DAM_ShutdownMusic:

Cleanup routine. Called when the user quits DoomAttack.


*********************************************************/


void C_DAM_ShutdownMusic(void)
{
	#ifdef __MAXON__
	CleanupModules();
	#endif
}

/*********************************************************

DAM_SetMusicVolume:

Volume is between 0 (min. volume) and 15 (max. volume).
There's a volume table used in the P61 plugin. Use this
if you want.


*********************************************************/


void C_DAM_SetMusicVolume(int volume)
{
}

/*********************************************************

DAM_PauseSong:

Stop playing of the song. DAM_ResumeSong will be called
later = playing should continue from where it was paused,
then.

*********************************************************/


void C_DAM_PauseSong(int handle)
{
}

/*********************************************************

DAM_ResumeSong:

Resume playing of a former paused song.

*********************************************************/


void C_DAM_ResumeSong(int handle)
{
}

/*********************************************************

DAM_StopSong:

Stop playing the song.

*********************************************************/

void C_DAM_StopSong(int handle)
{
}

/*********************************************************

DAM_RegisterSong:

To switch between different songs, DoomAttack uses

 DAM_RegisterSong

 DAM_PlaySong
 
 ...
 
 DAM_UnRegisterSong
 
<data> points to the MIDI music data in the WAD file
which was orignally meant to be used. <songnum> is
the music ID (see musicids.h). You can use <songnum>
in combination with a configuration file to allow the
user to change the songs/mods as shown in the P61A
plugin.

The routine can return a handle which other routines
such as DAM_PauseSong, DAM_UnRegisterSong, ... will
then get as parameter. Usually you can ignore this
handle as after a RegisterSong call there will never
be a second RegisterSong without a prior UnRegisterSong
call.

*********************************************************/


int C_DAM_RegisterSong(void *data,int songnum)
{
	return ????;
}

/*********************************************************

DAM_PlaySong:

Start playing the song. Have not yet checked if this
looping parameter is really used and what it is for ...

*********************************************************/


void C_DAM_PlaySong(int handle,int looping)
{
}

/*********************************************************

DAM_UnRegisterSong:

You usually will unload/free the actual song here.

*********************************************************/


void C_DAM_UnRegisterSong(int handle)
{
}

/*********************************************************

DAM_QrySongPlaying:

Return TRUE if the song is actually playing.
This routine does not seem to be used, but
implement it anyway.

*********************************************************/


int C_DAM_QrySongPlaying(int handle)
{
	return ????;
}


